/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  ^c/^break trap functions                                               *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 *  Thanks go to Peter Fitzsimmons for these routines.                     *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include "prog.h"

int brk_trapped=0;

#ifdef __MSC__
#define getvect(int)            _dos_getvect(int)
#define setvect(int, func)      _dos_setvect(int, func)
#define inportb(port)           inp(port)
#define outportb(port, byte)		outp(port, byte)
#endif

static void interrupt far new_9(void);
static void interrupt far trap_break(void);

void brktrap(void);
void brkuntrap(void);

static void (interrupt far *old_9)(void);
static void (interrupt far *old_23)(void);
static void (interrupt far *old_1b)(void);

static int brk_is_trapped=FALSE;

#ifdef OS_2
#include <signal.h>


static int handler(void)     /* Function called at system interrupt */
{

    signal(SIGINT, SIG_IGN); /* Disallow CTRL + C during handler   */

		brk_trapped++;

    signal(SIGINT,handler);       /* This is necessary so that the
                                ** next CTRL+C interrupt will call
                                ** "handler", since the DOS 3.x
                                ** operating system resets the
                                ** interrupt handler to the
                                ** system default after the
                                ** user-defined handler is called
                                */
    return(0);
}


void brktrap(void)
{
  if (!brk_is_trapped)
  {
    brk_is_trapped=TRUE;

    if (signal(SIGINT, handler) == (int(*) ()) -1)
    {
      fprintf(stderr, "Couldn't set SIGINT");
      return;
    }
  }
}


void brkuntrap(void)
{
    brk_is_trapped=FALSE;
    vbuf_flush();
}




#else




void brktrap(void)
{
  if (!brk_is_trapped)
  {
    brk_is_trapped=TRUE;

    old_23=getvect(0x23);    /* Dos ^C int */
    old_1b=getvect(0x1b);    /* Bios ^break int */
    old_9=getvect(0x09);     /* 8259 keyboard ISR */

    setvect(0x23,trap_break);
    setvect(0x1b,trap_break);
    setvect(0x09,new_9);
  }
}


void brkuntrap(void)
{
  if (brk_is_trapped)
  {
    brk_is_trapped=FALSE;

    setvect(0x23,old_23);     /* replace old ints */
    setvect(0x1b,old_1b);
    setvect(0x09,old_9);
  }
}


static void interrupt far new_9(void)
{
  static char far *shift_state=(char far *)0x417;

  static int scancode,
             kcode;

  if (*shift_state & 4)     /* CTRL pressed? */
  {
    scancode=inportb(0x60);

    if (scancode == 46)     /* 'C' key? */
    {       
      brk_trapped++;

      /* ACK key */
      kcode=inportb(0x61);
      outportb(0x61, kcode | 0x80);
      outportb(0x61, kcode);

      /* signal EOI (end of interrupt) to 8259 */
      outportb(0x20, 0x20);
      return;         /* IRET */
    }
  }

  (*old_9)();         /* Chain to next interrupt handler */
}


static void interrupt far trap_break(void)
{
	brk_trapped++;					 /* inc every time user hits ^break */
}

#endif

